#ifndef UTILS_H
#define UTILS_H


/** \file
  * \brief Useful macros */


/** \def ForAllJI(da)
    \brief Loop over indices of the domain */
#define ForAllJI(da) \
	PetscInt i0,j0,iw,jw; \
	DMDAGetCorners(da,&i0,&j0,NULL,&iw,&jw,NULL); \
	for (PetscInt j=j0; j<j0+jw; ++j) \
	for (PetscInt i=i0; i<i0+iw; ++i)


/** \def ForAllB(n)
    \brief Loop over bubbles (=identification fields) */
#define ForAllB(n) \
	for (PetscInt b=0; b<(n); ++b)


/** \def ForAllDim
    \brief Loop over the dimensions */
#define ForAllDim() \
	for (PetscInt dim=0; dim<2; ++dim)


#endif
